﻿namespace U2UConsult.WinRT.MVVM.Client.ViewModels
{
    using System;
    using System.Collections.Generic;
    using Mvvm;
    using Windows.UI.Xaml.Data;
    using Windows.UI.Xaml.Input;

    public class PublisherViewModel : INotifyPropertyChanged
    { 
        private string message;
        private Random rnd;
        
        public event PropertyChangedEventHandler PropertyChanged;

        public PublisherViewModel()
        {
            rnd = new Random(this.GetHashCode());
        }

        public string Message
        {
            get { return this.message; }
            set
            {
                this.message = value;
                this.PropertyChanged.Raise(this, (o) => o.Message);
            }
        }

        public ICommand UpdateTextCommand
        {
            get
            {
                return new DelegateCommand(this.UpdateTextCommand_Executed);
            }
        }

        private List<string> Texts
        {
            get
            {
                List<String> results = new List<string>();
                results.Add("Belgians were the first on the moon.");
                results.Add("Is that a rocket or are you happy to see me?");
                results.Add("I hope there is a toilet in that junk.");
                results.Add("Spielberg says that we look better in 3D.");
                results.Add("It's a small moon after all.");
                return results;
            }
        }

        private void UpdateTextCommand_Executed()
        {
            // Notify Bindings
            this.Message = this.Texts[rnd.Next(5)];
   
            // Notify Subscribers
            EventAggregator.Instance.Publish(this.Message);
        }
    }
}
