﻿namespace U2UConsult.WinRT.MVVM.Client.ViewModels
{
    using System;
    using System.Collections.Generic;
    using Mvvm;
    using Windows.UI.Xaml.Data;

    class SubscriberViewModel : INotifyPropertyChanged, IHandle<string>
    { 
        private string message;
        private Random rnd;

        public SubscriberViewModel()
        {
            EventAggregator.Instance.Subscribe(this);
            rnd = new Random(this.GetHashCode());
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private List<string> Texts
        {
            get
            {
                List<string> results = new List<string>();
                results.Add("Awesome!");
                results.Add("Cool!");
                results.Add("Burps! Sorry...");
                results.Add("Yeah, right...");
                results.Add("Allright, dude!");
                results.Add("Woohoo!");
                results.Add("I don't believe you!");
                return results;
            }
        }

        public string Message
        {
            get { return this.message; }
            set
            {
                this.message = value;
                this.PropertyChanged.Raise(this, (o) => o.Message);
            }
        }

        public void Handle(string message)
        {
            this.Message = this.Texts[rnd.Next(7)];
        }
    }
}
